package ink.wgink.module.file.media.task.transcoding.runnable;

import ink.wgink.module.file.media.manager.MediaManager;
import ink.wgink.module.file.media.manager.domain.enums.CrfValueEnum;
import ink.wgink.module.file.media.manager.domain.enums.PresetVauleEnum;
import ink.wgink.module.file.media.manager.process.IMediaStream;
import ink.wgink.module.file.media.service.video.IVideoService;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: VideoTransCodingRunnable
 * @Description: 视频转码
 * @Author: wanggeng
 * @Date: 2021/6/10 10:04 上午
 * @Version: 1.0
 */
public class VideoTransCodingRunnable implements Runnable {

    private String sourcePath;
    private String sourceName;
    private IVideoService videoService;

    @Override
    public void run() {
        File sourceFile = new File(sourcePath + File.separator + sourceName);
        File outFile = new File(sourcePath + File.separator + sourceName + ".mp4");
        MediaManager.getInstance().convertVideo(sourceFile, outFile, true, CrfValueEnum.HIGH_QUALITY.getCode(), PresetVauleEnum.MAX_FAST_ZIP_SPEED.getPresetValue(), null, null, new IMediaStream() {
            @Override
            public void input(InputStream inputStream) throws Exception {
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
                for (String line; (line = bufferedReader.readLine()) != null; ) {
                    System.out.println("input-" + line);
                }
            }

            @Override
            public void error(InputStream errorStream) throws Exception {
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(errorStream));
                for (String line; (line = bufferedReader.readLine()) != null; ) {
                    System.out.println("error-" + line);
                }
            }
        });
    }

}
